package de.intevation.gnv.math;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Ingo Weinzierl <ingo.weinzierl@intevation.de>
 */
public class XYColumn
implements   Serializable
{

    private double x;
    private double y;

    private int    i;
    private int    j;

    private List   values;

    public XYColumn(double x, double y, int i, int j) {
        this.x = x;
        this.y = y;
        this.i = i;
        this.j = j;
    }


    public void add(HeightValue value) {
        if (values == null) {
            values = new ArrayList();
        }
        values.add(value);
    }


    public HeightValue[] getValues() {
        return (HeightValue[]) values.toArray(new HeightValue[values.size()]);
    }


    public int hashCode() {
        return (i << 16) | j;
    }


    public boolean equals(Object obj) {
        XYColumn other = (XYColumn) obj;

        return i == other.i && j == other.j && x == other.x && y == other.y;
    }
}
